<template>
    <div>
        <label :for="fieldname">{{ label }}</label>
        <br>
        <textarea
            :id="fieldname"
            v-model="newValue"
            v-on:blur="changeValueIfNotTheSame"
            cols="30"
            rows="10"
            :disabled="disabled"
        ></textarea>
        <broject-database-fieldchanger
            :model="model"
            :model-id="modelId"
            :fieldname="fieldname"
            :old-value="oldValue"
            :new-value="newValue"
            :disabled="disabled"
            :changing="changing"
            @changed="onValueChanged"
        ></broject-database-fieldchanger>
    </div>
</template>

<script>
    import DatabaseFieldChanger from '../DatabaseFieldChanger.vue';

    export default {

        components: {
            'broject-database-fieldchanger': DatabaseFieldChanger,
        },

        props: {
            model: {
                type: String,
                required: true,
            },

            modelId: {
                type: Number,
                required: true,
            },

            fieldname: {
                type: String,
                required: true,
            },

            value: {
                type: String,
                default: null,
            },

            disabled: {
                type: Boolean,
                default: false,
            },

            label: {
                type: String,
                default: null,
            },
        },

        data() {
            return {
                changing: false,
                oldValue: this.value,
                newValue: this.value,
            }
        },

        methods: {
            changeValueIfNotTheSame() {
                if (this.oldValue !== this.newValue) {
                    this.changing = true;
                    this.$emit('changeInProgress');
                }
            },

            onValueChanged(result) {
                this.$emit('successfullyChanged');
                this.changing = false;
                this.oldValue = result.newValue;
                this.newValue = result.newValue;
            }
        }

    }
</script>
